
/******************************************************************************
* MODULE     : conv_singlet.cc
* DESCRIPTION: Build tuple with one element during conversion
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
namespace mmx {

void
evaluator_rep::kw_conv_singlet_1 () {
  CHECK_SYNC (CONV_SINGLET);
  evaluate_args (KW_CONV_SINGLET_2);
}

void
evaluator_rep::kw_conv_singlet_2 () {
  CHECK_SYNC (CONV_SINGLET);
  // INPUT: (conv_singlet_2, args, cont, ...)
  value   val = as_value (car (car (rem)));
  generic arg = list (MMX_TUPLE, val->val);
  generic type= list (ID_CROSS, val->type);
  cur= cadr (rem);
  rem= cons (value (arg, type), cddr (rem));
  // OUTPUT: (cont, tuple, ...)
  trace= cdr (trace);
}

} // namespace mmx
