
/******************************************************************************
* MODULE     : lexer.hh
* DESCRIPTION: Lexical analysis of mathemagix files
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __LEXER_HH
#define __LEXER_HH
#include <string.hh>
#include <symbol.hh>
namespace mmx {

#define YYSTYPE generic
#define yylval parse_lval
extern  YYSTYPE yylval;

extern int   lex_origin;
extern char* lex_string;
extern int   lex_length;
extern int   lex_start;
extern int   lex_prev;
extern int   lex_pos;
extern int   lex ();

inline void
start_lexer (string s) {
  lex_origin  = s->begin();
  lex_string  = S(s);
  lex_length  = N(s);
  lex_start   = 0;
  lex_prev    = 0;
  lex_pos     = 0;
}

}
#endif // __LEXER_HH
