
/******************************************************************************
* MODULE     : aliases.cc
* DESCRIPTION: Consider tuples of aliases as aliases
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <aliases.hh>
namespace mmx {

/******************************************************************************
* Required functions for generic structures
******************************************************************************/

int
aliases_rep::Type () {
  return ALIASES_TYPE;
}

/******************************************************************************
* Required functions for genalias structures
******************************************************************************/

static list
get_sub (list l) {
  if (nil (l)) return l;
  return cons (as_genalias (car (l)) -> get (), get_sub (cdr (l)));
}

generic
aliases_rep::get () {
  return cons (car (g), get_sub (cdr (as_list (g))));
}

static void
set_sub (list l, list r) {
  if (nil (l) || nil (r)) return;
  as_genalias (car (l)) -> set (car (r));
  set_sub (cdr (l), cdr (r));
}

void
aliases_rep::set (generic val) {
  set_sub (cdr (as_list (g)), cdr (as_list (val)));
}

} // namespace mmx
