
/******************************************************************************
* MODULE     : aliases.hh
* DESCRIPTION: Consider tuples of aliases as aliases
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __ALIASES_HH
#define __ALIASES_HH
#include <genalias.hh>
#include <list.hh>
namespace mmx {

class aliases;
class aliases_rep: public genalias_rep {
protected:
  generic g;    // a tuple of aliases
  int Type ();

public:
  inline aliases_rep (generic g2): g (g2) {}
  generic get ();
  void set (generic val);

  friend class aliases;
};

class aliases {
protected:
  aliases_rep* rep;
  inline aliases (aliases_rep* rep2): rep (rep2) {}

public:
  inline aliases (generic g):
    rep (new aliases_rep (g)) {}
  inline friend aliases as_aliases (generic g) {
    if (gentype(g) != ALIASES_TYPE) type_mismatch (g, "aliases");
    return aliases ((aliases_rep*) g.rep); }
  inline operator generic () { return generic (rep); }
  inline aliases_rep* operator -> () { return rep; }

  friend class aliases_rep;
};

}
#endif // __ALIASES_HH
